import { isNumber as y, isString as G, getPrefixCls as K, isObject as F } from "@gx-design-vue/pro-utils";
import { provide as U, inject as q, defineComponent as Y, ref as v, computed as L, onBeforeUnmount as V, watch as A, createVNode as h, Transition as _, withDirectives as J, vShow as Q, Fragment as Z, nextTick as D, onMounted as ee } from "vue";
import { useEventListener as W, isClient as te, useResizeObserver as I } from "@vueuse/core";
import { getTransitionProps as le, Keyframe as j, useProStyle as ae } from "@gx-design-vue/pro-provider";
const oe = {
  /**
   * @description height of scrollbar
   */
  height: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description max height of scrollbar
   */
  maxHeight: {
    type: [String, Number],
    default: ""
  },
  /**
   * @description whether to use the native scrollbar
   */
  native: {
    type: Boolean,
    default: !1
  },
  /**
   * @description style of wrap
   */
  wrapStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description class of wrap
   */
  wrapClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description class of view
   */
  viewClass: {
    type: [String, Array],
    default: ""
  },
  /**
   * @description style of view
   */
  viewStyle: {
    type: [Object, String],
    default: ""
  },
  /**
   * @description do not respond to container size changes, if the container size does not change, it is better to set it to optimize performance
   */
  noresize: Boolean,
  /**
   * @description element tag of the view
   */
  tag: {
    type: String,
    default: "div"
  },
  /**
   * @description always show
   */
  always: Boolean,
  /**
   * @description minimum size of scrollbar
   */
  minSize: {
    type: Number,
    default: 20
  }
}, ne = {
  scroll: ({ scrollTop: e, scrollLeft: u }) => y(e) && y(u)
}, p = Symbol("scrollbarContextKey"), ie = (e = Symbol(), u) => q(e, u || {}), re = (e) => {
  U(p, e);
}, se = () => ie(p, {}), ue = {
  always: {
    type: Boolean,
    default: !0
  },
  width: String,
  height: String,
  ratioX: {
    type: Number,
    default: 1
  },
  ratioY: {
    type: Number,
    default: 1
  }
}, ce = {
  vertical: Boolean,
  size: String,
  move: Number,
  ratio: {
    type: Number,
    required: !0
  },
  always: Boolean
}, fe = {
  vertical: {
    offset: "offsetHeight",
    scroll: "scrollTop",
    scrollSize: "scrollHeight",
    size: "height",
    key: "vertical",
    axis: "Y",
    client: "clientY",
    direction: "top"
  },
  horizontal: {
    offset: "offsetWidth",
    scroll: "scrollLeft",
    scrollSize: "scrollWidth",
    size: "width",
    key: "horizontal",
    axis: "X",
    client: "clientX",
    direction: "left"
  }
}, ve = (e) => G(e) ? !Number.isNaN(Number(e)) : !1, de = ({ move: e, size: u, bar: i }) => ({
  [i.size]: u,
  transform: `translate${i.axis}(${e}%)`
});
function O(e, u = "px") {
  if (!e)
    return "";
  if (y(e) || ve(e))
    return `${e}${u}`;
  if (G(e))
    return e;
  console.warn("utils/dom/style", "value 必须为数字");
}
const X = /* @__PURE__ */ Y({
  props: ce,
  setup(e) {
    const {
      hashId: u,
      wrapElement: i,
      scrollbarElement: w,
      className: d
    } = se(), m = v(), n = v(), c = v({}), s = v(!1);
    let g = !1, a = !1, b = te ? document.onselectstart : null;
    const l = L(() => fe[e.vertical ? "vertical" : "horizontal"]), H = L(() => de({
      size: e.size,
      move: e.move,
      bar: l.value
    })), x = L(() => (
      // offsetRatioX = original width of thumb / current width of thumb / ratioX
      // offsetRatioY = original height of thumb / current height of thumb / ratioY
      // instance height = wrap height - GAP
      m.value[l.value.offset] ** 2 / i.value[l.value.scrollSize] / ((e == null ? void 0 : e.ratio) || 0) / n.value[l.value.offset]
    )), T = (o) => {
      var t;
      if (o.stopPropagation(), o.ctrlKey || [1, 2].includes(o.button))
        return;
      (t = window.getSelection()) == null || t.removeAllRanges(), N(o);
      const r = o.currentTarget;
      r && (c.value[l.value.axis] = r[l.value.offset] - (o[l.value.client] - r.getBoundingClientRect()[l.value.direction]));
    }, P = (o) => {
      if (!n.value || !m.value || !i.value)
        return;
      const r = Math.abs(o.target.getBoundingClientRect()[l.value.direction] - o[l.value.client]), t = n.value[l.value.offset] / 2, f = (r - t) * 100 * x.value / m.value[l.value.offset];
      i.value[l.value.scroll] = f * i.value[l.value.scrollSize] / 100;
    }, N = (o) => {
      o.stopImmediatePropagation(), g = !0, document.addEventListener("mousemove", S), document.addEventListener("mouseup", z), b = document.onselectstart, document.onselectstart = () => !1;
    }, S = (o) => {
      if (!m.value || !n.value || g === !1)
        return;
      const r = c.value[l.value.axis];
      if (!r)
        return;
      const t = (m.value.getBoundingClientRect()[l.value.direction] - o[l.value.client]) * -1, f = n.value[l.value.offset] - r, C = (t - f) * 100 * x.value / m.value[l.value.offset];
      i.value[l.value.scroll] = C * i.value[l.value.scrollSize] / 100;
    }, z = () => {
      g = !1, c.value[l.value.axis] = 0, document.removeEventListener("mousemove", S), document.removeEventListener("mouseup", z), $(), a && (s.value = !1);
    }, B = () => {
      a = !1, s.value = !!e.size;
    }, M = () => {
      a = !0, s.value = g;
    };
    V(() => {
      $(), document.removeEventListener("mouseup", z);
    });
    const $ = () => {
      document.onselectstart !== b && (document.onselectstart = b);
    };
    return A(() => w.value, (o) => {
      W(o, "mousemove", B), W(o, "mouseleave", M);
    }), () => {
      const o = le(`${d}-fade`);
      return h(_, o, {
        default: () => [J(h("div", {
          ref: m,
          class: [`${d}-bar`, "is-" + l.value.key, u.value],
          onMousedown: P
        }, [h("div", {
          ref: n,
          class: `${d}-thumb ${u.value}`,
          style: H.value,
          onMousedown: T
        }, null)]), [[Q, e.always || s.value]])]
      });
    };
  }
});
X.inheritAttrs = !1;
const me = /* @__PURE__ */ Y({
  inheritAttrs: !1,
  props: ue,
  setup(e, {
    expose: u
  }) {
    const i = v(0), w = v(0), d = 4;
    return u({
      handleScroll: (n) => {
        if (n) {
          const c = n.offsetHeight - d, s = n.offsetWidth - d;
          w.value = n.scrollTop * 100 / c * e.ratioY, i.value = n.scrollLeft * 100 / s * e.ratioX;
        }
      }
    }), () => h(Z, null, [h(X, {
      move: i.value,
      ratio: e.ratioX,
      size: e.width,
      always: e.always
    }, null), h(X, {
      move: w.value,
      ratio: e.ratioY,
      size: e.height,
      vertical: !0,
      always: e.always
    }, null)]);
  }
}), he = new j("fadeIn", {
  "0%": {
    opacity: 0
  },
  "100%": {
    opacity: 1
  }
}), ge = new j("fadeOut", {
  "0%": {
    opacity: 1
  },
  "100%": {
    opacity: 0
  }
}), be = (e) => ({
  [`${e.componentCls}`]: {
    position: "relative",
    height: "100%",
    overflow: "hidden",
    ["&-wrap"]: {
      height: "100%",
      overflow: "auto",
      ["&-hidden-default"]: {
        scrollbarWidth: "none",
        ["&::-webkit-scrollbar"]: {
          display: "none"
        }
      }
    },
    ["&-bar"]: {
      position: "absolute",
      right: 2,
      bottom: 2,
      zIndex: 1,
      borderRadius: 4,
      ["&.is-vertical"]: {
        top: 2,
        width: 6,
        ["& > div"]: {
          width: "100%"
        }
      },
      ["&.is-horizontal"]: {
        left: 2,
        height: 6,
        ["& > div"]: {
          height: "100%"
        }
      }
    },
    ["&-thumb"]: {
      position: "relative",
      display: "block",
      width: 0,
      height: 0,
      cursor: "pointer",
      backgroundColor: "rgba(0, 0, 0, 0.25)",
      borderRadius: e.borderRadius,
      transition: ".3s background-color",
      ["&:hover"]: {
        backgroundColor: "rgba(0, 0, 0, 0.4)"
      }
    },
    ["&-fade-appear, &-fade-enter"]: {
      animationName: he,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    },
    ["&-fade-leave"]: {
      animationName: ge,
      animationDuration: ".34s",
      animationTimingFunction: "ease-out"
    }
  }
}), Se = /* @__PURE__ */ Y({
  name: "GScrollbars",
  props: oe,
  emits: ne,
  setup(e, {
    emit: u,
    slots: i,
    expose: w
  }) {
    const d = K({
      suffixCls: "scrollbar"
    }), {
      wrapSSR: m,
      hashId: n
    } = ae("ScrollBar", [be], d);
    let c, s;
    const g = v(), a = v(), b = v(), l = v("0"), H = v("0"), x = v(), T = v(1), P = v(1), N = "GScrollbars", S = 4, z = L(() => {
      const t = {};
      return e.height && (t.height = O(e.height)), e.maxHeight && (t.maxHeight = O(e.maxHeight)), [e.wrapStyle, t];
    }), B = () => {
      var t;
      a.value && ((t = x.value) == null || t.handleScroll(a.value), u("scroll", {
        scrollTop: a.value.scrollTop,
        scrollLeft: a.value.scrollLeft
      }));
    };
    function M(t, f) {
      F(t) ? a.value.scrollTo(t) : y(t) && y(f) && a.value.scrollTo(t, f);
    }
    const $ = (t) => {
      if (!y(t)) {
        console.warn(N, "value 必须为数字");
        return;
      }
      a.value.scrollTop = t;
    }, o = (t) => {
      if (!y(t)) {
        console.warn(N, "value 必须为数字");
        return;
      }
      a.value.scrollLeft = t;
    }, r = () => {
      if (!a.value)
        return;
      const t = a.value.offsetHeight - S, f = a.value.offsetWidth - S, C = t ** 2 / a.value.scrollHeight, R = f ** 2 / a.value.scrollWidth, k = Math.max(C, e.minSize), E = Math.max(R, e.minSize);
      T.value = C / (t - C) / (k / (t - k)), P.value = R / (f - R) / (E / (f - E)), H.value = k + S < t ? `${k}px` : "", l.value = E + S < f ? `${E}px` : "";
    };
    return A(() => e.noresize, (t) => {
      t ? (c == null || c(), s == null || s()) : ({
        stop: c
      } = I(b, r), s = W("resize", r));
    }, {
      immediate: !0
    }), A(() => e.noresize, (t) => {
      t ? (c == null || c(), s == null || s()) : ({
        stop: c
      } = I(b, r), s = W("resize", r));
    }, {
      immediate: !0
    }), A(() => [e.maxHeight, e.height], () => {
      e.native || D(() => {
        var t;
        r(), a.value && ((t = x.value) == null || t.handleScroll(a.value));
      });
    }), re({
      hashId: n,
      className: d,
      wrapElement: a,
      scrollbarElement: g
    }), ee(() => {
      e.native || D(() => r());
    }), w({
      /** @description scrollbar wrap ref */
      wrapRef: a,
      /** @description update scrollbar state manually */
      update: r,
      /** @description scrolls to a particular set of coordinates */
      scrollTo: M,
      /** @description set distance to scroll top */
      setScrollTop: $,
      /** @description set distance to scroll left */
      setScrollLeft: o,
      /** @description handle scroll event */
      handleScroll: B
    }), () => {
      const t = e.tag;
      return m(h("div", {
        ref: g,
        class: `${d} ${n.value}`
      }, [h("div", {
        ref: a,
        class: [n.value, e.wrapClass, `${d}-wrap`, e.native ? "" : `${d}-wrap-hidden-default`],
        style: z.value,
        onScroll: B
      }, [h(t, {
        ref: b,
        class: [`${d}-view`, e.viewClass, n.value],
        style: e.viewStyle
      }, {
        default: () => {
          var f;
          return [(f = i.default) == null ? void 0 : f.call(i)];
        }
      })]), !e.native && h(me, {
        ref: x,
        height: H.value,
        width: l.value,
        always: e.always,
        ratioX: P.value,
        ratioY: T.value
      }, null)]));
    };
  }
});
Se.inheritAttrs = !1;
export {
  Se as GScrollbars,
  Se as default,
  oe as scrollbarProps
};
